
#include <libintl.h>
#include <locale.h>
#define _(mens) gettext(mens)
#define N_(mens) (mens)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "arbolesOcre.h"
#include "convcar.h"
#include "distrib2.h"
#include "glifos.h"
#include "glifoscc.h"
#include "imag.h"
#include "imagio.h"
#include "parecido.h"

// Importante: para el codigo de estad_distans_...   glifoscc.h

// un caracter, 1-instancia <--> n-instancias, ==
//     la primera vez la lista fue de aes.
void estad_distans_01 (lista listaaes)
{
  // int i;
  int d;
  tglifo glifo1, glifoi;
  tvent  vent1, venti;
  tnodol nodol;
  tacumdist acum;
  acum = nuevoAcumDist (5, 10000000);
  // glifo1 = (tglifo) (enesimoNodoDeLista(listaaes,2)->aitem);
  glifo1 = listaaes->primero->siguiente->aitem;
  vent1 = glifo1->venDeGlifo;
  for (nodol = listaaes->primero->siguiente->siguiente;
       nodol != 0L; nodol = nodol->siguiente) {
    glifoi = (tglifo) (nodol->aitem);
    venti = glifoi->venDeGlifo;
    d = comparaVent (vent1, venti);
    // printf ("distancia: %8d\n", d);
    // if ((d >= 10))
    //    printf (" %6d %5d %5d\n", d, glifoi->ideglifo, glifo1->ideglifo);
    anyadeaAcumDist (acum, d);
    }
  printf ("un caracter:%s, 1-instancia <--> n-instancias, ==\n", glifo1->letras);
  imprimeAcumDist (acum);
}

// un caracter, n-instancias <--> n-instancias, ==
void estad_distans_02 (lista listaaes)
{
  int d;
  tglifo glifoj, glifoi;
  tvent  ventj, venti;
  tnodol nodol;
  tnodol nodolj;
  tacumdist acum;
  acum = nuevoAcumDist (5, 10000000);
  for (nodolj = listaaes->primero->siguiente->siguiente;
       nodolj != 0L; nodolj = nodolj->siguiente) {
    glifoj = (tglifo) (nodolj->aitem);
    ventj = glifoj->venDeGlifo;
    for (nodol = listaaes->primero->siguiente->siguiente;
         nodol != 0L; nodol = nodol->siguiente) {
      glifoi = (tglifo) (nodol->aitem);
      venti = glifoi->venDeGlifo;
      d = comparaVent (ventj, venti);
      anyadeaAcumDist (acum, d);
      }
    }
  printf ("un caracter:%s, n-instancias <--> n-instancias, ==\n",
                                   (char *) listaaes->primero->aitem);
  imprimeAcumDist (acum);
}

// un caracter, n-instancias <--> n-instancias, !=
void estad_distans_04 (lista listaaes, lista lista2gl)
{
  int d;
  tglifo glifoj, glifoi;
  tvent  ventj, venti;
  lista lista1c;
  tnodol nodol;
  tnodol nodolj, nodolk;
  tacumdist acum;
  acum = nuevoAcumDist (5, 10000000);
  for (nodolk = lista2gl->primero;
       nodolk != 0L; nodolk = nodolk->siguiente) {
    lista1c = (lista) (nodolk->aitem);
    if (lista1c != listaaes){
      for (nodolj = lista1c->primero->siguiente->siguiente;
           nodolj != 0L; nodolj = nodolj->siguiente) {
        glifoj = (tglifo) (nodolj->aitem);
        ventj = glifoj->venDeGlifo;
        for (nodol = listaaes->primero->siguiente->siguiente;
             nodol != 0L; nodol = nodol->siguiente) {
          glifoi = (tglifo) (nodol->aitem);
          venti = glifoi->venDeGlifo;
          d = comparaVent (ventj, venti);
          anyadeaAcumDist (acum, d);
          }
        }
      }
    }
  printf ("un caracter:%s, n-instancias <--> n-instancias, !=\n",
                                   (char *) listaaes->primero->aitem);
  imprimeAcumDist (acum);
}

        // if (! distintochar && (d >= 20))
        //   printf (" %6d %5d %5d %3s %3s\n", d,
        //         glifoj->ideglifo, glifoi->ideglifo, glifoj->letras, glifoi->letras);
        //
/*
         if (distintochar && (d < 25))
           printf (" %6d %5d %5d %3s %3s\n", d,
                 glifoj->ideglifo, glifoi->ideglifo, glifoj->letras, glifoi->letras);
*/
/*
        if (! distintochar && (dd >= 20))
           printf (" %6d %6d %6d %5d %5d %3s %3s\n", dd, d1, d2,
                 glifoj->ideglifo, glifoi->ideglifo, glifoj->letras, glifoi->letras);
*/
        //
        // if ((distintochar && (d < 1024)) && (glifoj->letras[0] != 'c'))
        //   printf (" %6d %5d %5d %3s %3s\n", d,
        //         glifoj->ideglifo, glifoi->ideglifo, glifoj->letras, glifoi->letras);
        //
        // if (glifoj->letras[0] != 'c')
     //   anyadeaAcumDist2 (acum2, d, distintochar);
     //   anyadeaAcumDist2 (acum2, dd, distintochar);

void comparaYacumDist2 (tglifo glifoi, tglifo glifoj,
                        Boolean distintochar, tacumdist2 acum2)
{
  tvent venti, ventj;
  int d1, d2, D1; // , D20, D2, dd;
  // int d;
  venti = glifoi->venDeGlifo;
  ventj = glifoj->venDeGlifo;
  // d  = comparaVent (ventj, venti);   // inicial
  d1 = comparaVent (ventj, venti);   // inicial
  d2 = comparaVent (venti, ventj);
  D1 = max(d1,d2);
  // D20 = min(d1,d2); D2 = max(D20,1);
  // dd = (D1-D2) * 8 / D2;
  anyadeaAcumDist2 (acum2, D1, distintochar);
}

// un caracter, n-instancias <--> n-instancias, == y !=
void recorrelistas2gl1blAplicando (lista listaaes, lista lista2gl,
                    void comparaYacumDist2(tglifo g1, tglifo g2,
                                           Boolean dist, tacumdist2 acum2),
                    tacumdist2 acum2)
{
  tglifo glifoi, glifoj;
  lista lista1c;
  tnodol nodol;
  tnodol nodolj, nodolk;
  Boolean distintochar;
  // todos los glifos en listas 2 niveles
  for (nodolk = lista2gl->primero;
       nodolk != 0L; nodolk = nodolk->siguiente) {
    lista1c = (lista) (nodolk->aitem);
    distintochar = (lista1c != listaaes);
      // distintochar = TRUE;       // 1  base.h
      // distintochar = FALSE;      // 0  base.h
    for (nodolj = lista1c->primero->siguiente->siguiente;
         nodolj != 0L; nodolj = nodolj->siguiente) {
      glifoj = (tglifo) (nodolj->aitem);
      // comparados con 1 tipo de glifo
      for (nodol = listaaes->primero->siguiente->siguiente;
           nodol != 0L; nodol = nodol->siguiente) {
        glifoi = (tglifo) (nodol->aitem);
        comparaYacumDist2 (glifoi, glifoj, distintochar, acum2);
        }
      }
    }
}


// un caracter, n-instancias <--> n-instancias, == y !=
void recorre2listas2glAplicando (lista lista2gl2, lista lista2gl,
                    void comparaYacumDist2(tglifo g1, tglifo g2,
                                           Boolean dist, tacumdist2 acum2),
                    tacumdist2 acum2)
{
  tglifo glifoi, glifoj;
  lista lista1c, lista1c2;
  tnodol nodol;
  tnodol nodoli, nodolj, nodolk;
  Boolean distintochar;
  // todos los glifos en listas 2 niveles
  for (nodolk = lista2gl->primero;
       nodolk != 0L; nodolk = nodolk->siguiente) {
    lista1c = (lista) (nodolk->aitem);
    for (nodolj = lista1c->primero->siguiente->siguiente;
         nodolj != 0L; nodolj = nodolj->siguiente) {
      glifoj = (tglifo) (nodolj->aitem);
      // comparados con N tipos de glifo
      for (nodoli = lista2gl2->primero;
           nodoli != 0L; nodoli = nodoli->siguiente) {
        lista1c2 = (lista) (nodoli->aitem);
        distintochar = (lista1c != lista1c2);
        // comparados con 1 tipo de glifo
        for (nodol = lista1c2->primero->siguiente->siguiente;
             nodol != 0L; nodol = nodol->siguiente) {
          glifoi = (tglifo) (nodol->aitem);
          comparaYacumDist2 (glifoi, glifoj, distintochar, acum2);
          }
        }
      }
    }
}

// un caracter, n-instancias <--> n-instancias, == y !=
void estad_distans_06 (lista listaaes, lista lista2gl)
{
  tacumdist2 acum2;
  acum2 = nuevoAcumDist2 (6, 10000000);
  recorrelistas2gl1blAplicando (listaaes, lista2gl, comparaYacumDist2, acum2);
  printf ("un caracter:%s, n-instancias <--> n-instancias, == y !=\n",
                                   (char *) listaaes->primero->aitem);
  imprimeAcumDist2falsosPond (acum2, 10);
}

// cualquier glifo  con  cualquier glifo, == y !=
void estad_distans_08 (lista lista2gl)
{
  tacumdist2 acum2;
  acum2 = nuevoAcumDist2 (6, 10000000);
  recorre2listas2glAplicando (lista2gl, lista2gl, comparaYacumDist2, acum2);
  printf ("cualquier glifo  con  cualquier glifo, == y !=\n");
  imprimeAcumDist2falsosPond (acum2, 10);
}

void estad_distans_Todo (tglifo * glifoG)
{
  tglifoscc glifoscc;
  lista listaaes;
// comienzo_local 
  glifoscc = glifosccNueva ();
  aniadeNaglifoscc (glifoscc, glifoG[0]);
//  imprimeFreqglifoscc (glifoscc);
//
// listaaes = (lista) (enesimoNodoDeLista(glifoscc,5)->aitem);
//  listaaes = (lista) (enesimoNodoDeLista(glifoscc,3)->aitem);
  listaaes = glifos1charDeglifoscc (glifoscc, "i");
//  estad_distans_01 (listaaes);
//  estad_distans_02 (listaaes);
//  estad_distans_04 (listaaes, glifoscc);
  estad_distans_06 (listaaes, glifoscc);
  estad_distans_08 (glifoscc);
// fin_local
}


