
// glifos tipo char clasificados
// glifos      c    c            glifosCC
// implementado mediante
//     lista de listas de glifos tipo char ordenados por chars
// lista de ( listas con primer elemento (*char) y los demas tglifo

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "glifos.h"
#include "glifoscc.h"
#include "lista.h"

tglifoscc glifosccNueva ()
{
  return listaNueva ();
}

void aniade1aglifoscc (tglifoscc glifoscc, tglifo glifochar)
{
  tnodol nodol;
  lista li;
  lista li2;
  char * tira;
  for (nodol = glifoscc->primero; nodol != 0L;nodol = nodol->siguiente) {
    li = (lista) (nodol->aitem);
    if ( strcmp( ((char *)(li->primero->aitem)), glifochar->letras) == 0){
      aniadeafinlista (li, glifochar);
      break ;
      }
    }
  if (nodol == 0L) {
    li2 =  listaNueva ();
    tira = strdup (glifochar->letras);
    aniadeafinlista (li2, tira);
    aniadeafinlista (li2, glifochar);
    //
    aniadeafinlista (glifoscc, li2);
    }
}

void aniade1aglifosccAux (tglifo glifochar, tpgen glifoscc)
{
  aniade1aglifoscc ((tglifoscc)glifoscc, glifochar);
}

void aniadeNaglifoscc (tglifoscc glifoscc, tglifo glifocomp)
{
  aplicaGtRFncD (glifocomp, glifCar, aniade1aglifosccAux, (tpgen) glifoscc);
}

void liberaglifoscc (tglifoscc glifoscc)
{
  lista li;
  tnodol nodol;
  for (nodol = glifoscc->primero; nodol != 0L;nodol = nodol->siguiente) {
    li = (lista) (nodol->aitem);
    free (li->primero->aitem);
    liberaNodosYlista (li);
    }
  liberaNodosYlista (glifoscc);
}

void imprimeFreqglifoscc (tglifoscc glifoscc)
{
  lista li;
  tnodol nodol;
  for (nodol = glifoscc->primero; nodol != 0L;nodol = nodol->siguiente) {
    li = (lista) (nodol->aitem);
    printf("%3s %4d\n", (char *)(li->primero->aitem), longLista (li)-1);
    } 
}

lista glifos1charDeglifoscc (tglifoscc glifoscc, char * ch)
{
  tnodol nodol;
  lista li;
  for (nodol = glifoscc->primero; nodol != 0L;nodol = nodol->siguiente) {
    li = (lista) (nodol->aitem);
    if ( strcmp( ((char *)(li->primero->aitem)), ch) == 0)
      break ;
    }
  return li;
}

