
#include "base.h"

#define INCLF_DIV 65536
#define INCLF_DIVR 32768

#define inclf_desvx(INCL,DY) (((DY)*(INCL) + ((INCL)>0 ? 32768 : -32768))/65536)
#define inclf_absDesvx(INCL,DY) ((abs(INCL)*(DY)+32768)/65536)

typedef struct tecuadrltr{
  int xne, yne, xno, yno,
      xso, yso, xse, yse;
  int x0, x1, y0, y1;    
  } * tcuadrltr;

void pon_vprim_vult (int inc, int tu, int tv, int *vprim, int *vult);

void pon_vprim_vultR (int inc, int tu, int tv, int *vprim, int *vult);

void pon_paralogr (int inclH, int y0, int y1, int inclV, int x0, int x1,
                   tcuadrltr cuadrltr);

void imprime_paralogr (tcuadrltr cuad);
