
#include <string.h>
#include <stdio.h>

char * ultimoUtf8 (char * s)
{
  char * u;
  int i = strlen (s);
  //  empieza por 10xx xxxx ==  bbbb bbbb & 1100 0000 -> 10oo oooo
  while ((i>0) && ((s[i-1] & 0xc0) == 0x80))
    i--;
  u = strdup(&(s[i-1]));
  return u;
}

char * primerUtf8 (char *s)
{
  char * p;
  int l;
  int nc;
  nc = (s[0] & 0xff) ;
  if (nc < 128)
    l = 1;
  else if (nc < 224)
    l = 2;
  else if (nc < 240)
    l = 3;
  else
    l = 4;
  p = (char *) malloc (l+1);
  strncpy (p, s, l);
  p[l+1] = '\0';
  return p;
}
