
#include <libintl.h>
#include <locale.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define _(mens) gettext(mens)
#define N_(mens) (mens)

#include "artefactos.h"
#include "atributos.h"
#include "convcar.h"
#include "doblesHor.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "imag.h"
#include "imagAcum.h"
#include "imagAcum2.h"
#include "imagx.h"
#include "libro.h"
#include "lineaText.h"
#include "opcns.h"
#include "parcela.h"
#include "pauta.h"
#include "reconoce.h"
#include "repasa.h"
#include "segmenta0.h"
#include "segmenta.h"
#include "tipos.h"

void segmReconoceyRepasaColumnaP (tglifo * nglifoColumnaP, tvent vent, int * n)
{
  tglifo glifoColumnaP;
  tvent ventSc, ventCap;
  Boolean hayCap;
  tglifo glifoCap;
  if (d_valori >= 6)
    printf ("segmReconoceyRepasaColumnaP\n");
//  segmentaSiCapitular (&hayCap, vent);
  segmentaSiCapitular (&hayCap, &ventSc, &ventCap, vent);
//  ventSc = vent;
  segmentaColumnaP (ventSc);
  glifoColumnaP = glifoCompClmpNuevo ();
  casaGlifoVent (glifoColumnaP, ventSc);
  reconoceColumnaP (glifoColumnaP);
  // printf ("ANTES DE CAPITULAR\n");
  // describeGlifo (glifoColumnaP, 3);
  if (hayCap) {
    glifoCap = glifoLetNuevo ("0?");
    casaGlifoVent (glifoCap, ventCap);
    anyadeAtributoAlista (ventCap->atributs, "capitular", (tpgen)TRUE);
    reconoceChar (glifoCap, 3);   // 3 o menor, opcns.c
    ponCapitularenGlifoCP (glifoColumnaP, ventCap, vent);
    }
  // printf ("DESPUES DE CAPITULAR\n");
  // describeGlifo (glifoColumnaP, 1);
  // correcciones
  repasaPautas (glifoColumnaP);
  // pautasenColumnaP (glifoColumnaP); 
  quitaArtefactos (glifoColumnaP);
  corrigeGuionesFindeLinea (glifoColumnaP);
  enlazaPalabrasPartidas (glifoColumnaP);
  //
  repasaColumnaP (glifoColumnaP);
  // enlazaPalabrasPartidas (glifoColumnaP);  // nuevas lecturas?
/**/
  repasaDobleshColumnaP (glifoColumnaP);
  // repasaPautas (glifoColumnaP);
  calculaAlineamientos (glifoColumnaP); 
/**/
/* comienzo_local */
  if (p_valori == 32) {
    // escribePalabrasdeGlifosenLista (glifoColumnaP->listaGlifos);
    separaTipos (glifoColumnaP);
    exit (0);
    }
/* fin_local */
  *nglifoColumnaP = glifoColumnaP;
}

void escribeColumnaP (tglifo * nglifoColumnaP, tvent vent, int * n)
{
  int nc;
  int ng, ng2;
  tglifo glifoColumnaP;
  glifoColumnaP = *nglifoColumnaP ;
  if (y_opcion && ((y_valori >= 1)&&(y_valori <= 3))) {
    if (d_valori >= 10)
      printf ("escribePautas glifoColumnap\n");
    escribePautas (glifoColumnaP);
    }
// comienzo_local
  ng  = *n ;
  ng2 = *n ;
  numeraGlifosenLista (glifoColumnaP, &ng2);
  if (p_valori == 22) {
    escribePalabrasdeGlifosenLista (glifoColumnaP->listaGlifos);
    }
  else if (p_valori == 29) {
    escribePalabrasLogdeGlifosenLista (glifoColumnaP->listaGlifos);
    }
  else
// fin_local
  if (y_opcion && (y_valori != 3))
    escribeLetrasdeGlifosenLista (glifoColumnaP->listaGlifos, n);
// comienzo_local
  if ((p_valori == 5) || (p_valori == 35)) {
    escribeVentanasdeGlifosenLista (glifoColumnaP, &ng, "arm1");
    if (ng != ng2)
      printf (" error en escribeColumnaP, ng: %4d ng2: %4d\n",
               ng, ng2) ;
    }
  if (S_opcion) {
    nc = nincognitasEnGlifo (glifoColumnaP);
    printf ("glifos no reconocidos: %5d\n", nc);
    marcaGlifosNoReconocidos (glifoColumnaP) ;
    // presentaVentanayPara (ventSc, "sal26.pgm", 1);
    presentaVentanayPara (vent, "sal26.pgm", 1);
    }
// fin_local
  // *nglifoColumnaP = glifoColumnaP;
}

void segmReconoceRepasayEscribeColumnaP (tglifo * nglifoColumnaP, tvent vent, int * n)
{
  segmReconoceyRepasaColumnaP (nglifoColumnaP, vent, n);
  // describeGlifo (* nglifoColumnaP, 1);
  escribeColumnaP (nglifoColumnaP, vent, n);
}

void segmReconoceyRepasaG (tglifo * nglifoG, tvent vent, int * n)
{
  tvent ventPag0, ventPag1;
  tglifo glifoPliego;
  tglifo glifoPag0, glifoPag1;
  if (d_valori >= 4)
    printf ("segmReconoceyRepasaG\n");
  if (b_opcion) {             // dos caras, libro
    /* if (bvalor[0] == 'c') .... */
    segmentaLibroPaginas (vent, &ventPag0, &ventPag1);
    // prepara (ventPag0);
    glifoPliego = glifoCompPliegoNuevo ();
    casaGlifoVent (glifoPliego, vent);
    /** /
    {int nh;
    presentaVentana (&nh, ventPag0, "sal26iz.pgm", 1);
    presentaVentana (&nh, ventPag1, "sal26de.pgm", 1);
    // presentaVentanayPara (ventPag1, "sal26de.pgm", 1);
    }
    / **/
    segmReconoceRepasayEscribeColumnaP (&glifoPag0, ventPag0, n);
    adoptaGlifo (glifoPliego, glifoPag0);
    segmReconoceRepasayEscribeColumnaP (&glifoPag1, ventPag1, n);
    adoptaGlifo (glifoPliego, glifoPag1);
    *nglifoG = glifoPliego;
    }
  else if (A_opcion) {
    parcela (vent);
    printf ("paso por segmReconoceyRepasaG con A_opcion\n");
    }
  else
    segmReconoceRepasayEscribeColumnaP (nglifoG, vent, n);
  if (C_opcion) {         // refinado de glifos
    timagAcum imagAcum;
    timagf imaga;
    char caracUnic[128], caracUstr[128];
    char nomsal[128];
    if ( esUstr(C_valor) ){
      utf8DeUstr (caracUnic, C_valor);
      strcpy (caracUstr, C_valor);
      }
    else {
      strcpy (caracUnic, C_valor);
      ustrDeUtf8 (caracUstr, C_valor);
      }
    imagAcum = imagenAcumDecharsEnglifo (8, caracUnic, *nglifoG);
    printf(" %s: %4d\n", caracUstr, imagAcum->n);
    if (imagAcum->n > 0) {
      imagenDeImagenAcum (&imaga, imagAcum);
      sprintf (nomsal, "carRef%s.pgm", caracUstr);
      presentaVentanayPara (imaga->ven0, nomsal, 1);
      }
    }
}
