
#ifndef _LISTA_H
#define _LISTA_H

#include "base.h"

typedef struct nodol{
  struct nodol *anterior, *siguiente;
  tpgen aitem;
  } * tnodol;

typedef struct lista{
  tnodol primero, ultimo;
  } * lista;

lista listaNueva ();

Boolean listaVacia (lista l);

void aniadeacomlista (lista l, tpgen g );

void aniadeNafinlista (lista l, tnodol nodol);

void aniadeafinlista (lista l, tpgen g );

void pasalistaafinlista (lista ld, lista lo);

void aniadealistaAntes (lista l, tpgen g , tnodol nodol);

lista copiaLista (lista l);

lista copiaListaReves (lista l);

lista headNlista (lista l, int n);

void eliminaNdelista (lista l, tnodol nodol);

void primerNodoAlFinal (lista l);

Boolean eliminaItemdelista (lista l, tpgen item);

Boolean cambiaItemdelista (lista ld, lista lo, tpgen item);

void substituyePorListaNodo  (lista l, lista la , tnodol nodol);

void recorreListaAplicando (lista l, void fn(tpgen));

void recorreListaAplicandoMasdat (lista l, tpgen dat, void fn(tpgen, tpgen));

void eliminaDeListaSiFuncResul (lista l, Boolean fn(tpgen), Boolean resul);

void eliminaDeListaSiFuncEResul (lista l, tpgen dat, Boolean fn(tpgen, tpgen), Boolean resul);

tnodol buscaEnListaSiFuncEResul (lista l, tpgen dat, Boolean fn(tpgen, tpgen), Boolean resul);

tnodol maximIEnlista (lista l, int fn(tpgen));

tnodol minimIEnlista (lista l, int fn(tpgen));

lista ordenadaLista (lista l, int fn(tpgen));

int longLista (lista l);

void plongLista2 (lista l);

tnodol enesimoNodoDeLista (lista l, int n);

void liberaNodosYlista (lista l);

void liberaItemsNodosYlista (lista l);

void intermcambiaNodosDelistas (lista l1, lista l2);

lista cierreTransitivo (lista l, Boolean r(tpgen, tpgen));

int tirarPrograma ();

Boolean longListaMenorQue (tpgen l, tpgen tmin);


#endif /* _LISTA_H */

